import * as React from 'react';
import {
  Table, Header, Container, Form, Checkbox, Button, Rating,
  List, Icon, ButtonProps,
} from 'semantic-ui-react';
import {SensorConfigPopup} from '@overflow/sensor/react/components/sensor_config_popup';

export interface StateProps {
}

export interface DispatchProps {
}

export type Props = StateProps & DispatchProps;

export interface State {
  sensorConfigStart: boolean;
}

export class InfraMapZoneTableRow extends React.Component<Props, State> {

  constructor(props: Props, context: State) {
    super(props, context);

    this.state = {
      sensorConfigStart: false,
    };
  }

  public openSensorConfig(event: React.MouseEvent<HTMLButtonElement>, data: ButtonProps): void {
    this.setState({
      sensorConfigStart: true,
    });
  }

  public closeSensorConfig(): void {
    this.setState({
      sensorConfigStart: false,
    });
  }


  public render(): JSX.Element {
    return (
      <Table.Row>
        <Table.Cell>
          <Header textAlign='center'>Windows / Probe</Header>
        </Table.Cell>
        <Table.Cell>
          <List>
            <List.Item>Host : 192.168.1.106</List.Item>
            <List.Item>Service :
                <List horizontal>
                <List.Item>FTP</List.Item>
                <List.Item>MySQL</List.Item>
                <List.Item>SMB</List.Item>
              </List>
            </List.Item>
            <List.Item>Sensors(2) :
                <List horizontal>
                <List.Item>
                  <Icon link name='square' />FTP
                    </List.Item>
                <List.Item>
                  <Icon link name='square outline' />MySQL
                    </List.Item>
              </List>
              <Button.Group floated='right'>
                <Button onClick={this.openSensorConfig.bind(this)}>Add Sensor</Button>
              </Button.Group>
            </List.Item>
          </List>
        </Table.Cell>
        <SensorConfigPopup open={this.state.sensorConfigStart} closeCallback={this.closeSensorConfig.bind(this)}/>
      </Table.Row>
    );
  }

}
